{*****************************************************************************}
{*									     *}
{*	       Copyright (C) 1985 by Borland International, INC.	     *}
{*									     *}
{*				    GO-MOKU				     *}
{*			    Corrected for UniPascal			     *}
{*			    by George Petrov  /YGP/			     *}
{*									     *}
{*	This program plays a very old Japanese game called GO-MOKU, perhaps  *}
{*  better known as  5-in-line.  The game is played on a board with 19 x 19  *}
{*  squares, and the object of the game is to get 5 stones in a row.	     *}
{*									     *}
{*****************************************************************************}

{$define UpDt_InLine}
{$define Add_InLine}
{ $define cnst}
{ $define timing}
program XO(message);						       {$R-,I-}
  (*)
  uses UniCRT; { $i ..\inlines }
  {*)
  uses CRT, UniPascal, DOS;
  const MsgLimit = 40;
  {*}
  {$ifdef timing}
  var minh, minm, mins, mins100: cardinal;
      maxh, maxm, maxs, maxs100: cardinal;
  {$endif}

  const VisibleY = 25;
	MaxXsz =  38;				      { Max Size of the board }
	MaxYsz =  20;
	EmptyCh = '';

	LeftKey  = (*) #$c1 {*) #75 {*};
	RightKey = (*) #$c2 {*) #77 {*};
	DownKey  = (*) #$c3 {*) #80 {*};
	UpKey	 = (*) #$c4 {*) #72 {*};

	_F1	 = (*) #$c9 {*) #59 {*};
	_F10	 = (*) #$d2 {*) #68 {*};

	Esc	     = #27;
	Enter	     = (*)#$c0{*)#13{*};
	Space	     = #32;
	AttackFactor =	 4;		       { Importance of attack (1..16) }
			     { Value of having 0, 1,2,3,4 or 5 pieces in line }

  type TypeOfWin  = (Null, Horiz, DownLeft, DownRight, Vert);
       BoardType  = (Empty, Cross, Nought);	       { Contents of a square }
       PlayerType = Cross..Nought;			    { The two players }
       XIndexType = 0..MaxXsz;			       { Index to the board X }
       YIndexType = 0..MaxYsz;			       { Index to the board Y }
       NumberType = 0..5;			 { Number of pieces in a line }
       LineType   = packed array [PlayerType] of NumberType;
       ValueType  = array [PlayerType] of cardinal;
       BoardLine = packed array [YIndexType] of BoardType;
       ValueLine = array [YIndexType] of ValueType;
					    { Value of square for each player }

  {$ifdef cnst}
  const xsize = 19; ysize = 19;
  {$else}
  var Xsize, Ysize: ShortCard;		   { ⢨⥫   ᪠ }
  {$endif}
  var ScreenX, ScreenY, 		{      ࠭ }
      MessX, MessY,			       { X,Y   ꮡ饭 }
      TotalX:	ShortCard;		  { Total chars occupeyd by the Board }
      Xdist:	ShortCard;			    { Distance between Square }
      X:	XIndexType;				  { X Move coordinate }
      Y:	YIndexType;				  { Y Move coordinate }
      AutoPlay: boolean;		   { The program plays against itself }
      Border:	boolean;		 { There is a border around the board }
      Command:	char;				      { Command from keyboard }
      Player:	PlayerType;		      { The player whose move is next }
      TtlLines: integer;		     { The number of empty lines left }
      GameWon:	boolean;		  { Set if one of the players has won }
      WinLine:	TypeOfWin;				       { Wininng Line }
      MsgOn:	boolean;		  { The presence of message on screen }
      OldAplay: boolean;
      Weight1,
      Weight0:	array[0..5] of integer;
      PieceCh:	packed array[PlayerType] of char;
      Board:	array [XIndexType] of BoardLine;		  { The board }
      Value:	array [XIndexType] of ValueLine;
				       { Value of each square for each player }

      Line0,
      Line1,
      Line2,
      Line3:	 array [XIndexType, YIndexType] of LineType;
			     { Number of pieces in each of all possible lines }
      SngBorder:string[11];

  procedure ClrKbd;
  begin
    while Keypressed do if (Readkey = #0) and (Readkey = #0) then;
  end { ClrKbd };

  procedure ResetGame(FirstGame: boolean); forward;

  procedure WriteKEYS((*)const(*) s: string); forward;

  procedure BlinkWinner(Piece: PlayerType;
			 X:    XIndexType;
			 Y:    YIndexType;
		  WinningLine: TypeOfWin;
		  PlayerWon:   boolean);   forward;

  procedure center((*) const (*) s: string);
  begin
    write(s: (MsgLimit + length(s)) div 2);
  end { center };

  procedure PrintMsg((*)const(*) str: string);		   { Prints a message }
    var svX, svY: byte;
  begin
    (*) PassCrsr(0); (*)
    svX:= WhereX; svY:= WhereY;
    GotoXY(MessX, MessY);
    Center(str); ClrEol; GotoXY(svX, svY);
    (*) PassCrsr(4); (*)
    MsgOn:= true;					   { Set the presence }
  end { PrintMsg };

  procedure ClearMsg;
    var svX, svY: byte;
  begin 						 { Clears the message }
	  { if no message present on screen then we haven't anything to clear }
    if MsgOn then begin
      (*) PassCrsr(0); (*)
      svX:= WhereX; svY:= WhereY;
      GotoXY(MessX, MessY); ClrEol;
      GotoXY(svX, svY);
      (*) PassCrsr(4); (*)
    end { if };
    MsgOn:= false;
  end { ClearMsg };

  procedure GotoSquare(X: XIndexType; Y: YIndexType);
  begin
    (* GotoXY(1, ScreenY); Write(TtlLines:5); <- test print *)
    GotoXY(ord(Border) + (X - 1) * Xdist + 1, Ysize + 1 + 1 + ord(Border) - Y);
  end { GotoSquare };

  procedure PrintMove(Piece: PlayerType; X: XIndexType; Y: YIndexType);
  begin
    GotoSquare(X, Y);
    write(PieceCh[Piece]);
    GotoSquare(X, Y);
  end { PrintMove };

  function OpponentColor(Player: PlayerType): PlayerType;
  begin
    if Player = Cross then
      OpponentColor:= Nought
    else
      OpponentColor:= Cross;
  end { OpponentColor };

  procedure MakeMove(X: XIndexType; Y: YIndexType);
    { Performs the move X,Y for player, and updates the global variables
      (Board, Line, Value, Player, GameWon, TtlLines and the screen)   }

    var Oppnnt:    PlayerType;
	X1 ,Y1:      integer;
	K, L:	     NumberType;				   {$ifdef FUN}
	MaxNum:      NumberType;				       {$endif}

    {$ifdef Add_InLn}
      var num: NumberType;
    {$else}
    procedure Add(var Num: LineType);
    begin			 { Adds one to the number of pieces in a line }
      inc(Num[player]); 			{ Adds one to the number.     }
      case Num[player] of
       1: dec(TtlLines);			{ If it is the first piece in }
						{ the line, then the opponent }
						{ cannot use it any more.     }
       5: GameWon:= true;			{ The game is won if there    }
						{ are 5 in line.	      }
      end { case };
      {$ifdef FUN}
      if MaxNum < Num[player] then MaxNum:= Num[player];{ Save MaxNum for fun }
      {$endif}
    end { Add };
    {$endif}

    {$ifdef UpDt_InLine }
      var Lin: ^LineType;
	  Val: ^ValueType;
    {$else}
    procedure Update(Lin: LineType; var Valu: ValueType);
    { Updates the value of a square for each player, taking into account that }
    { player has placed an  extra piece in the square.	The value of a square }
    { in a usable  line is  Weight[Lin[Player]+1]  where  Lin[Player]  is the }
    { number of pieces already placed in the line.			      }
    begin	     { If the opponent has no pieces in the line, then simply }
      if Lin[Oppnnt] = 0 then			{ update the value for player }
	inc(Valu[Player], Weight0[Lin[Player]])
      else if Lin[Player] = 1 then {If it is the first piece in the line, then}
	dec(Valu[Oppnnt], Weight1[Lin[Oppnnt]]);		{ the line is }
    end { Update };				   { spoiled for the opponent }
    {$endif}

  begin 							   { MakeMove }
    WinLine:= Null; GameWon:= false;				   {$ifdef FUN}
    MaxNum:= 0; 						       {$endif}
    Oppnnt:= OpponentColor(Player);

    PrintMove(Player, X, Y);			       { Print move on screen }

    {	Each square of the board is part of 20 different lines. The procedure }
    { adds one to the number of pieces in each of these lines. Then it updates}
    { the value for  each of the  5 squares in	each of the 20 lines. Finally }
    { Board is updated, and the move is printed on the screen.		      }

    for K:= 0 to 4 do begin	       { Horizontal lines, from left to right }
      X1:= X - K; Y1:= Y;			   { Calculate starting point }
      if (1 <= X1) and (X1 <= Xsize - 4) then begin    { Check starting point }
	{$ifdef Add_InLn}
	inc(Line0[X1, Y1, Player]);			    { Add one to line }
	case Line0[X1, Y1, Player] of
	 1: dec(TtlLines);			{ If it is the first piece in }
			{ the line, then the opponent cannot use it any more. }
	 5: GameWon:= true;			{ The game is won if there    }
							     { are 5 in line. }
	end { case };
	{$else}
	Add(Line0[X1, Y1{, Player}]);			    { Add one to line }
	{$endif}
	if GameWon and (WinLine = Null) then		  { Save winning line }
	  WinLine:= Horiz;
	for L:= 0 to 4 do begin   { Update value for the 5 squares in the line}
	  {$ifdef UpDt_InLine }
	  Lin:= addr(Line0[X1, Y1]); Val:= addr(Value[X1 + L, Y1]);
	  if Lin^[Oppnnt] = 0 then
	    inc(Val^[Player], Weight0[Lin^[Player]])
	  else if Lin^[Player] = 1 then
	    dec(Val^[Oppnnt], Weight1[Lin^[Oppnnt]]);
	  {$else}
	  Update(Line0[X1, Y1], Value[X1 + L, Y1]);
	  {$endif}
	end { for };
      end { if };
    end { for k:= 0 to 4 };

    for K:= 0 to 4 do begin  { Diagonal lines, from lower left to upper right }
      X1:= X - K; Y1:= Y - K;
      if (1 <= X1) and (X1 <= Xsize - 4) and
	 (1 <= Y1) and (Y1 <= Ysize - 4) then begin
	{$ifdef Add_InLn}
	inc(Line1[X1, Y1, Player]);			    { Add one to line }
	case Line1[X1, Y1, Player] of
	 1: dec(TtlLines);			{ If it is the first piece in }
			{ the line, then the opponent cannot use it any more. }
	 5: GameWon:= true;			{ The game is won if there    }
							     { are 5 in line. }
	end { case };
	{$else}
	Add(Line1[X1, Y1{, Player}]);			    { Add one to line }
	{$endif}
	if GameWon and (WinLine = Null) then		  { Save winning line }
	  WinLine:= DownLeft;
	for L:= 0 to 4 do begin   { Update value for the 5 squares in the line}
	  {$ifdef UpDt_InLine }
	  Lin:= addr(Line1[X1, Y1]); Val:= addr(Value[X1 + L, Y1 + L]);
	  if Lin^[Oppnnt] = 0 then
	    inc(Val^[Player], Weight0[Lin^[Player]])
	  else if Lin^[Player] = 1 then
	    dec(Val^[Oppnnt], Weight1[Lin^[Oppnnt]]);
	  {$else}
	  Update(Line1[X1, Y1], Value[X1 + L, Y1 + L]);
	  {$endif}
	end { for };
      end { if };
    end { for k:= 0 to 4 };

    for K:= 0 to 4 do begin		    { Vertical lines, from down to up }
      X1:= X; Y1:= Y - K;
      if (1 <= Y1) and (Y1 <= Ysize - 4) then begin
	{$ifdef Add_InLn}
	inc(Line2[X1, Y1, Player]);			    { Add one to line }
	case Line2[X1, Y1, Player] of
	 1: dec(TtlLines);			{ If it is the first piece in }
			{ the line, then the opponent cannot use it any more. }
	 5: GameWon:= true;			{ The game is won if there    }
							     { are 5 in line. }
	end { case };
	{$else}
	Add(Line2[X1, Y1{, Player}]);			    { Add one to line }
	{$endif}
	if GameWon and (WinLine = Null) then		  { Save winning line }
	  WinLine:= Vert;
	for L:= 0 to 4 do begin   { Update value for the 5 squares in the line}
	  {$ifdef UpDt_InLine }
	  Lin:= addr(Line2[X1, Y1]); Val:= addr(Value[X1, Y1 + L]);
	  if Lin^[Oppnnt] = 0 then
	    inc(Val^[Player], Weight0[Lin^[Player]])
	  else if Lin^[Player] = 1 then
	    dec(Val^[Oppnnt], Weight1[Lin^[Oppnnt]]);
	  {$else}
	  Update(Line2[X1, Y1], Value[X1, Y1 + L]);
	  {$endif}
	end { for };
      end { if };
    end { for k:= 0 to 4 };

    for K:= 0 to 4 do begin	   { Diagonal lines, down right to upper left }
      X1:= X + K; Y1:= Y - K;
      if (5 <= X1) and (X1 <= Xsize) and
	 (1 <= Y1) and (Y1 <= Ysize - 4) then begin
	{$ifdef Add_InLn}
	inc(Line3[X1, Y1, Player]);			    { Add one to line }
	case Line3[X1, Y1, Player] of
	 1: dec(TtlLines);			{ If it is the first piece in }
			{ the line, then the opponent cannot use it any more. }
	 5: GameWon:= true;			{ The game is won if there    }
							     { are 5 in line. }
	end { case };
	{$else}
	Add(Line3[X1, Y1{, Player}]);			    { Add one to line }
	{$endif}
	if GameWon and (WinLine = Null) then		  { Save winning line }
	  WinLine:= DownRight;
	for L:= 0 to 4 do begin   { Update value for the 5 squares in the line}
	  {$ifdef UpDt_InLine }
	  Lin:= addr(Line3[X1, Y1]); Val:= addr(Value[X1 - L, Y1 + L]);
	  if Lin^[Oppnnt] = 0 then
	    inc(Val^[Player], Weight0[Lin^[Player]])
	  else if Lin^[Player] = 1 then
	    dec(Val^[Oppnnt], Weight1[Lin^[Oppnnt]]);
	  {$else}
	  Update(Line3[X1, Y1], Value[X1 - L, Y1 + L]);
	  {$endif}
	end { for };
      end { if };
    end { for k:= 0 to 4 };

    Board[X, Y]:= Player;			       { Place piece in board }

    Player:= Oppnnt;			       { The opponent is next to move }
    {$ifdef FUN}
    if (Command = 'P') or (Command = 'A') then
      (* case MaxNum of    ᠤ ᪠
	   3: PrintMsg('  ஡ .');
	   4: PrintMsg(' ᥣ?');
	   end { case } *)
    else begin
      case MaxNum of
	3: PrintMsg('ꬬ');
	4: PrintMsg(' ﬠ   ꤥ');
      end { case };
    end { if };
    {$endif}
  end { MakeMove };

  function GameOver: boolean;
  begin   { A game is over if one of the players have won, or if there are no }
    GameOver:= GameWon or (TtlLines <= 0);		  { more empty lines. }
  end { GameOver };

  procedure FindMove(var X: XIndexType; var Y: YIndexType);
  { Finds a move X,Y for player, simply by
    picking the one with the highest value }
    var Oppnnt:  PlayerType;
	I:	   XIndexType;
	J:	   YIndexType;
	Max, Valu: cardinal;
	BL:	   ^BoardLine;
	VL:	   ^ValueLine;

    {$ifdef div16}
    function div16(c: cardinal): cardinal;
    code $5f, $d, 18, { SNCI 18 }
	 $30,	      { tsx	}
	 $a6, $02,    { lda x, 2}
	 $e6, $03,    { ldb x, 3}
	 $54,	      { lsrb	}
	 $46,	      { rora	}
	 $54,	      { lsrb	}
	 $46,	      { rora	}
	 $54,	      { lsrb	}
	 $46,	      { rora	}
	 $54,	      { lsrb	}
	 $46,	      { rora	}
	 $a7, $02,    { sta x, 2}
	 $e7, $03,    { stb x, 3}
	 $39;	      { rts	}
    {$endif}

  begin
    Oppnnt:= OpponentColor(Player);
    Max:= {$ifdef old} -(*)standard.Max(Integer) {*) maxint {*} {$endif} 1;

    { If no square has a high value then pick the one in the middle }
    X:= (Xsize + 1) div 2; Y:= (Ysize + 1) div 2;
    { if Board[X, Y] = Empty then Max:= 4; }

    {	The evaluation for a square is simply the value of the square for the }
    { player (attack points) plus the value for the opponent (defense points).}
    { Attack is more  important than defense,  since it is better to get 5 in }
    { line yourself than to prevent the opponent from getting it.	      }

    for I:= 1 to Xsize do begin 		      { For all empty squares }
      BL:= addr(Board[i]);
      VL:= addr(Value[i]);
      for J:= 1 to Ysize do begin
	if BL^[J] = Empty then begin		       { Calculate evaluation }
	  Valu:= VL^[J, Player] * (16 + AttackFactor) div 16 +
		 VL^[J, Oppnnt]{ + random(4)};
	  if (Max < Valu) or (Max = Valu) and odd((*)random(0)
						  {*)random(100){*}) then begin { Pick move with highest value }
	    X:= I; Y:= J; Max:= Valu;
	  end { if };
	end { if }
      end { for }
    end { for };
  end { FindMove };

  procedure GetChar(var Ch: char);	  { Get a character from the keyboard }
  begin
    Ch:= upcase(Readkey);
  end { GetChar };

  procedure ReadCommand(X: XIndexType; Y: YIndexType; var Command: char);
    var ValidCommand: boolean;
  begin 				 { Reads in a valid command character }
    if GameOver and not GameWon then PrintMsg(' !');
    repeat
      ValidCommand:= true;
      GotoSquare(X, Y); 					{ Goto square }
      if not GameOver then begin
	PrintMsg('   室!');
      end { if };
      GetChar(Command); 				 { Read from keyboard }
      case Command of
	Esc: Command:= 'G';                            { <esc> means New Game }

	Enter,				       { Enter or space means place a }
	Space: Command:= ' ';                 { stone at the cursor position  }

	(*) {*)
	#0: begin GetChar(Command);
	    case Command of	  {*}
	      LeftKey:	Command:= 'J';
	      RightKey: Command:= 'K';
	      DownKey:	Command:= 'M';
	      UpKey:	Command:= 'I';
	      _F1:	Command:= 'H';
	      _F10:	Command:= 'Q';
	(*) {*)
	      else
		begin ValidCommand:= false; ClrKbd; end;
	      end (* case *);
	    end { #0 }; 						    {*}

	'G', 'Q', 'A', 'P', 'H': { OK };
	'I', 'J', 'K', 'M': { OK };

	'N': Command:= 'G';
	else (*):(*)
	     begin ValidCommand:= false;
	     ClrKbd;
	     end { case else };
	end { case };
    until ValidCommand;
  end { ReadCommand };

  procedure InterpretCommand(Command: char);
  begin
    case Command of
      'G': begin
	ResetGame(false);				     { Start new game }
	X:= (Xsize + 1) div 2; Y:= (Ysize + 1) div 2;
      end;

      'H': begin
	PrintMsg('-   ࠥ ...');
	FindMove(X, Y); 			       { Give the user a hint }
	PrintMsg('-   ࠥ ');
	GotoSquare(X, Y);
	repeat until KeyPressed;
      end;
      'J': X:= (X + Xsize - 2) mod Xsize + 1;                          { Left }
      'K': X:= X mod Xsize + 1;                                       { Right }
      'M': Y:= (Y + Ysize - 2) mod Ysize + 1;                          { Down }
      'I': Y:= Y mod Ysize + 1;                                          { Up }
{$ifdef Diagonals}
   (*  ਭ樯       堬. *)
      'U': begin                                          { Move diagonally   }
	Y:= Y MOD Ysize + 1;				  { toward upper left }
	X:= (X + Xsize - 2) MOD Xsize + 1;
      end;
      'O': begin                                         { Move diagonally    }
	Y:= Y MOD Ysize + 1;				 { toward upper right }
	X:= X MOD Xsize + 1;
      end;
      'N': begin                                          { Move diagonally   }
	Y:= (Y + Ysize - 2) MOD Ysize + 1;		  { toward lower left }
	X:= (X + Xsize - 2) MOD Xsize + 1;
      end;
      ',': begin                                         { Move diagonally    }
	Y:= (Y + Ysize - 2) MOD Ysize + 1;		 { toward lower right }
	X:= X MOD Xsize + 1;
      end;
{$endif}
      'A': begin AutoPlay:= true;                            { Auto play mode }
	PrintMsg(' ࠥ  ᥡ !');
      end;

    end { case };
    {
    if (Command <> 'A') and (Command <> 'H') then ClearMsg;
    }
  end { InterpretCommand };

  procedure PlayerMove; 			      { Enter and make a move }
  begin
    if Board[X, Y] = Empty then begin
      ClearMsg;
      MakeMove(X, Y);
      if GameWon then BlinkWinner(OpponentColor(Player), X, Y, WinLine, true);
      Command:= 'P';
    end { if };
  end { PlayerMove };

  procedure ProgramMove;		     { Find and perform programs move }
   {$ifdef Timing}
    var oldh, oldm, olds, olds100: cardinal;
	newh, newm, news, news100: cardinal;
	h, m, s, s100: integer;
	svx: word; svy: word;
   {$endif}
  begin
    (*) PassCrsr(4); (*)
    if not AutoPlay then
      PrintMsg('  ᢮ 室!');
    repeat
      if AutoPlay then delay(200);
      if Keypressed then begin
	ClrKbd; AutoPlay:= false; ClearMsg;
      end { if };
      if GameOver then begin
	AutoPlay:= false;
	if (Command <> 'Q') and (not GameWon) then begin
	  PrintMsg(' !');
	end { if }; end
      else begin
	{$ifdef Timing}
	GetTime(oldh, oldm, olds, olds100);
	{$endif}
	FindMove(X, Y);
	MakeMove(X, Y);
	{$ifdef Timing}
	GetTime(newh, newm, news, news100);
	svx:= wherex; svy:= wherey;
	gotoxy(1, 25);
	s100:= news100; s:= news; m:= newm; h:= newh;
	dec(s100, olds100);
	if s100 < 0 then begin
	  dec(s); inc(s100, 100);
	end { if };
	dec(s, olds);
	if s < 0 then begin
	  dec(m); inc(s, 60);
	end { if };
	dec(m, oldm);
	if m < 0 then begin
	  dec(h); inc(m, 60);
	end { if };
	dec(h, oldh);
	if h < 0 then begin
	  inc(h, 24);
	end { if };
	if (minh > h) or (minh = h) and (
	   (minm > m) or (minm = m) and (
	   (mins > s) or (mins = s) and (
	   (mins100 > s100) ))) then begin
	  minh:= h; minm:= m;  mins:= s; mins100:= s100;
	end { if };

	if (maxh < h) or (maxh = h) and (
	   (maxm < m) or (maxm = m) and (
	   (maxs < s) or (maxs = s) and (
	   (maxs100 < s100) ))) then begin
	  maxh:= h; maxm:= m;  maxs:= s; maxs100:= s100;
	end { if };

	write(minh: 2, ':', minm: 2, ':', mins: 2, '.', mins100: 2, ' <=');
	write(h: 2, ':', m: 2, ':', s: 2, '.', s100: 2, ' <=');
	write(maxh: 2, ':', maxm: 2, ':', maxs: 2, '.', maxs100: 2);
	gotoxy(svx, svy);
	{$endif}
	if GameWon then
	  BlinkWinner(OpponentColor(Player), X, Y, WinLine, false);
      end { if };
    until AutoPlay = false;
    ClearMsg; WriteKeys('');
  end { ProgramMove };

  procedure SetUpScreen;	     { Sets up the screen with an empty board }
    var TtlX, X, Y: ShortCard;
	Line: string[100];
  begin
    GotoXY(1, 1);
    center('  㫨窨'); writeln;

    (*) PassCrsr(0); (*) GotoXY(1, 2);
    TtlX:= TotalX + 2 - Xdist;
    Line[0]:= chr(TtlX); fillchar(Line[1], TtlX, ' ');

    {   Border 㢠 ࢨ ।   }
    if Border then begin
      fillchar(Line[1], TtlX, SngBorder[5]);
      Line[1]:= SngBorder[1];
      Line[TtlX]:= SngBorder[2];
      writeln(Line);
      fillchar(Line[2], TtlX, ' ');
      Line[1]:= SngBorder[6]; Line[TtlX]:= SngBorder[6];
      X:= 2; end
    else begin
      X:= 1;
    end { if };

    { ꫢ ।  - - - ... }
    repeat Line[X]:= EmptyCh;
      X:= X + Xdist;
    until X > TtlX - ord(Border);

    { ⯥⢠ 室 ன । }
    for Y:= 1 to Ysize do writeln(Line);

    {   Border 㢠 ᫥ ।   }
    if Border then begin
      fillchar(Line[2], TtlX, SngBorder[5]);
      Line[1]:= SngBorder[3];
      Line[TtlX]:= SngBorder[4];
      write(Line);
    end { if };
    (*) PassCrsr(4); (*)
  end { SetUpScreen };

  procedure WriteKEYS((*)const(*) s: string);
    var svX, svY: shortcard;
  begin
    if (OldAplay xor AutoPlay) or (s <> '') then begin
      svX:= whereX; svY:= whereY; OldAplay:= AutoPlay;
      GotoXY(1, 25); clreol;
      if s <> '' then
	center(s)
      else if AutoPlay then
	center('᭥   ४ᢠ!')
      else begin
	center('ESC  , F1 ᪠, F10 ࠩ');
      end { if };
      GotoXY(svX, svY);
    end { if };
  end { WriteKEYS };

  procedure ResetGame(FirstGame: boolean);
  begin 			{ Resets global variables to start a new game }
    SetUpScreen;
    X:= (Xsize + 1) div 2;			   { Set starting position to }
    Y:= (Ysize + 1) div 2;			   { the middle of the board  }
    GotoSquare(X, Y);
    if FirstGame then begin	 { ࢮ   訬 ꤥ  襬  }
{      GotoXY(1, 1); write('GOMOKU: NewGame, Quit, Auto, Play, Hint');  }
      AutoPlay := false; OldAplay:= true;
      WriteKeys('');
      MessX:= 1;
      MessY:= Ysize + ord(Border)*2 + 1 + 1;
      FirstGame:= false; end
    else begin
      ClearMsg;
    end { if };

    { ᢠ 窨 ⠡ }
    (*)FillWord{*)fillchar{*}(Board, (*)WordSizeOf{*)sizeof{*}(Board), 0);
    (*)FillWord{*)fillchar{*}(Value, (*)WordSizeOf{*)sizeof{*}(Value), 0);
    (*)FillWord{*)fillchar{*}(Line0, (*)WordSizeOf{*)sizeof{*}(Line0), 0);
    (*)FillWord{*)fillchar{*}(Line1, (*)WordSizeOf{*)sizeof{*}(Line1), 0);
    (*)FillWord{*)fillchar{*}(Line2, (*)WordSizeOf{*)sizeof{*}(Line2), 0);
    (*)FillWord{*)fillchar{*}(Line3, (*)WordSizeOf{*)sizeof{*}(Line3), 0);

    { 碠  }
    Player:= Cross;

    { ॡ  ன ન     ࠢ }
    {        < 4 }
    if Xsize < 4 then
      TtlLines:= 2 * Xsize * (Ysize - 4)
    else if Ysize < 4 then
      TtlLines:= 2 * Ysize * (Xsize - 4)
    else begin
      TtlLines:= 4 * (Xsize - 4) * (Ysize - 4) +
		 2 * (Xsize * (Ysize - 4) + Ysize * (Xsize - 4));
    end { if };

    GameWon:= false;				     {   ﬠ ⥫ }
  end { ResetGame };

  procedure BlinkWinner(Piece: PlayerType;
			 X:    XIndexType;
			 Y:    YIndexType;
		  WinningLine: TypeOfWin;
		  PlayerWon:   boolean);
    { Prints the 5 winning stones in blinking color }

    var XHold, YHold: integer;	  { Used to store the pos of the winning move }
	Dx, Dy: integer;				  { Change in X and Y }
	CantBlink: boolean;
	Ch: char;

    procedure BlinkRow(X, Y, Dx, Dy: integer; Ch: char);
      { Blink the row of 5 stones }
      var I: integer;
    begin
      for I:= 1 to 5 do begin
	GotoSquare(X, Y);
	write(Ch);
	X:= X - Dx; Y:= Y - Dy;
      end { for };
    end { BlinkRow };

  begin 							{ BlinkWinner }
    AutoPlay:= true; WriteKEYS('᭥    ');
    if PlayerWon then
      PrintMsg('ࠢ  !')
    else begin
      PrintMsg(' !');
    end { if };
    XHold:= X; YHold:= Y;			  { preserve winning position }
    case WinningLine of
      Horiz:	 begin Dx:= 1; Dy:= 0; end;
      DownLeft:  begin Dx:= 1; Dy:= 1; end;
      Vert:	 begin Dx:= 0; Dy:= 1; end;
      DownRight: begin Dx:= -1; Dy:= 1; end;
    end { case };
    while (Board[X + Dx, Y + Dy] <> Empty) and	    { go to topmost, leftmost }
	  (Board[X + Dx, Y + Dy] = Piece ) do begin
      X:= X + Dx; Y:= Y + Dy;
    end { while };

    CantBlink:= true;		   (* (TextFlavour(BlinkFlav) <> BlinkFlav); *)
    if CantBlink then begin
      Ch:= EmptyCh; (*) PassCrsr(0); (*)
      repeat BlinkRow(X, Y, Dx, Dy, Ch);
	GotoSquare(XHold, YHold); Delay(500);
	if Ch = EmptyCh then
	  Ch:= PieceCh[Piece]
	else begin
	  Ch:= EmptyCh;
	end { if };
      until Keypressed;
      (*) PassCrsr(4); (*)
    end { if };
    BlinkRow(X, Y, Dx, Dy, PieceCh[Piece]);
    (* CantBlink:= (TextFlavour(NoFlavour) <> NoFlavour); *)
    X:= XHold; Y:= YHold;			   { restore winning position }
    GotoSquare(X, Y);				  { go back to winning square }
    AutoPlay:= false; WriteKEYS('');
  end { BlinkWinner };

  procedure HelpScreen;
const
  help_xo : array [1..25] of string[40] = (
'            㫨窨',
'',
'          ꧤ',
'    -.',
'   ࠢ    . ',
'    ᫥⥫ ⠢頻',
'ᥪ ᢮   ᪠  ࠧ 19x19',
' ⮧,   ᯥ  -',
'⠢   ᢮    ।, -',
'⨪  .',
'     ਬ୨  訫  -',
'   ⠢ <X>.',
'',
'                     ',
'    X O O O        X    O  ',
'   X X X X X O      O X X X X O  ',
'    O X O           X    ',
'               O O O X   ',
'                   X  ',
'                    O ',
'',
'          ᯥ!',
'',
'',
'  ᭥ <ࢠ>   ࠥ!');
  var i:byte;
  begin
     clrscr;
     for i:=1 to 25 do
       writeln('                     '+help_xo[i]);
     if (readkey = #0) (*){*)and (readkey = #0){*} then;
     clrscr;
  end { HelpScreen };


  procedure Initialize;
    var ScrX, ScrY: ShortCard;

    {$ifNdef cnst}
    function GetByte((*)const(*) Msg: string;
		     (*)const(*) Min, Max, Dflt: ShortCard): ShortCard;
      var w: integer;
	  Ch: char;
	  first: boolean;
    begin
      repeat w:= Dflt;					      { default value }
	write(#13, Msg, w:3, #8#8#8);
	first:= true;
	repeat Ch:= Readkey;
	  if ('0' < Ch) and (Ch <= '9') or
	     ('0' = Ch) and not first then begin{ 㫠   ࢨ  }
	    if first then begin
	      ClrEol; w:= 0;
	    end { if };
	    first:= false;
	    w:= w * 10 + ord(Ch) - ord('0');
	    if Max < w then begin
	      w:= w div 10; ClrEol;
	      write('      [', Min, '..', Max, ']');
	      write(#13,Msg, w); end
	    else begin
	      write(Ch);
	    end { if }; end
	  else begin
	    case Ch of
	      LeftKey:	if (w <> 0) and not first then begin
			  write(#8' '#8);
			  w:= w div 10;
			  first:= w = 0;
			end;
	      Enter:	Ch:= ' ';
	      ' ':      { OK };
	      else (*):(*) write(#7);
	    end { case };
	  end { if };
	until Ch = ' ';
	if w < Min then begin
	  write('      [', Min, '..', Max, ']');
	  write(#13,Msg, w);
	end { if };
      until (Min <= w) and (w <= Max);
      GetByte:= w;
      write(#13, Msg, w:3); ClrEol;
      writeln;
    end { GetByte };
    {$endif}

(*)
    procedure TextCo40;
    code $5f, $d, 6,  { SNCI 6	}
	 $4f,	      { clra	}
	 $c6, $70,    { ldb #$70}
	 $3f, $12,    { int $12 }
	 $39;	      { rts	}
(*)
  begin 							 { Initialize }
    {   ৠ ࠡ    㢠 ᠬ weight  ⮩:
	  Weight[0]:=	0; Weight[1]:=	 0; Weight[2]:=   4; Weight[3]:=  20;
	  Weight[4]:= 100; Weight[5]:= 600; Weight[6]:=   0;
         㢠 ᠬ  ᫥ ࠧ:
	  weight[x+1]; weight[x+1] - weight[x];
       :
	  weight1[x] = weight[x+1]; weight0[x] = weight[x+1] - weight[x]
       ⠪ ᯥ ( 19x19 )  10 ⭨.		      }

    Weight0[0]:=   0; Weight1[0]:=   0;  {    ⢥⭨ ன }
    Weight0[1]:=   4; Weight1[1]:=   4; 	       {   㫨窨 }
    Weight0[2]:=  16; Weight1[2]:=  20;      { ᨢ       }
    Weight0[3]:=  80; Weight1[3]:= 100;      { ᪮  ꫤ () }
    Weight0[4]:= 400; Weight1[4]:= 500; { 魮 ꤥ ꤥ  㢠 }
    Weight0[5]:=   0; Weight1[5]:=   0; { Weight1    㢠 Weight[+1]}

    PieceCh[Cross]:= 'X'; PieceCh[Nought]:= 'O';

    SngBorder:= 'ڿĳô';

    TextColor(15); TextBackground(0);   HelpScreen;
    (*) TextCo40; {*) TextMode(co40); {*}
    TextColor(10); TextBackground(0);

    ClrScr; randomize; AutoPlay:= false;

    ScrX:= MsgLimit; ScrY:= VisibleY;

    if ScrX = 0 then ScrX:= 80;      {  ⭠ ꫦ । 80 }
    if ScrY = 0 then ScrY:= 24;      {  ⭠ ꫦ । 24 }

    ScreenX:= ScrX; ScreenY:= ScrY;

    if (ScrX < 20) or (ScrY < 7) then begin
      writeln('Can''t run!');
      halt(0);
    end { if };

    ScrY:= ScrY - 2;				       {   । ࠧ }

    if ScrX > MaxXsz then ScrX:= MaxXsz;
    if ScrY > MaxYsz then ScrY:= MaxYsz;

    {$ifNdef cnst}
      writeln(' ࠧ  ᪠ ᪠');
      Xsize:= GetByte('  ன : ', 1, ScrX, 19);
      if Xsize >= 5 then
	Ysize:= GetByte('  ன ।: ', 1, ScrY, 19)
      else begin
	Ysize:= GetByte('  ன ।: ', 5, ScrY, 19);
      end { if };
    {$endif}

    Xdist:= ScreenX div Xsize; if Xdist > 2 then Xdist:= 2;
    TotalX:= Xdist * Xsize - 1; Border:= false;

    if (TotalX < ScreenX - 1) and (Ysize < ScreenY - 1) then begin
      TotalX:= TotalX + 2; Border:= true;
    end { if };
    ClrScr;
  end { Initialize };


begin							       { Program Body }
  Initialize;
  ResetGame(true);		       { ResetGame and draw the entire screen }
  (*) ActvCrsr(4); PassCrsr(4); (*)
  {$ifdef Timing}
  minh:= 23; minm:= 59; mins:= 59; mins100:= 99;
  maxh:=  0; maxm:=  0; maxs:=	0; maxs100:=  0;
  {$endif}
  repeat ReadCommand(X, Y, Command);
    if GameOver and (Command <> 'Q') then Command:= 'G';
    InterpretCommand(Command); WriteKEYS('');
    if Command = ' ' then PlayerMove;
    if (Command = 'P') or (Command = 'A') then ProgramMove;
  until Command = 'Q';
  ClearMsg; (*) PassCrsr(0); (*)
  GotoXY(1, ScreenY);	  clreol;
  GotoXY(1, ScreenY - 1); clreol;
  TextMode(co80); NormVideo;
end.
